	NOLIST
;******  useful  macros  ************************


bank0	macro
	bcf	STATUS,RP1
	bcf	STATUS,RP0
	endm

bank1	macro
	bcf	STATUS,RP1
	bsf	STATUS,RP0
	endm

bank2	macro
	bsf	STATUS,RP1
	bcf	STATUS,RP0
	endm

bank3	macro
	bsf	STATUS,RP1
	bsf	STATUS,RP0
	endm

page0	macro			;0000h - 07ffh (0 - 2047)
	bcf	PCLATH,4
	bcf	PCLATH,3
	endm

page1	macro			;0800h - 0fffh (2048 - 4095)
	bcf	PCLATH,4
	bsf	PCLATH,3
	endm

page2	macro			;1000h - 17ffh (4096 - 6143)
	bsf	PCLATH,4
	bcf	PCLATH,3
	endm

page3	macro			;1800h - 1fffh (6144 - 8191)
	bsf	PCLATH,4
	bsf	PCLATH,3
	endm

#define	_Z	STATUS,Z
#define	_C	STATUS,C

;*** file and literal  comparison skip macros  ***************************************


sfgtl	macro	file,lit	;skip if file > lit

	movfw	file
	sublw	lit		;lit - file, if res -ve then file > lit
	btfsc	STATUS,C

	endm

sfgtel  macro	file, lit   ;skip next instr if value in file >= literal

	movlw	lit
	subwf	file,w
	btfss	STATUS,C
	
	endm

sfltl	macro	file, lit   ;skip next instr if value in file < literal

	movlw	lit
	subwf	file,w
	btfsc	STATUS,C	

	endm

sfltel	macro	file,lit	;skip if file <= lit

	movfw	file
	sublw	lit		;lit - file, if res 0 or +ve then file <= lit
	btfss	STATUS,C

	endm

sfnz	macro	file	    ;skip next instr if value in file is not zero	

	movf	file,F
	btfsc	STATUS,Z
	
	endm

sfz	macro	file	    ;skip next instr if value in file is zero

	movf	file,F
	btfss	STATUS,Z

	endm

sfel	macro	file,lit	;skip if file == lit

	movlw	lit
	xorwf	file,W
	btfss	STATUS,Z

	endm

sfnel	macro	file,lit	;skip if file != lit

	movlw	lit
	xorwf	file,W
	btfsc	STATUS,Z

	endm	

;******** file1 and file2 comparison skip macros   ******************************************

sfgtf	macro	file1,file2	;skip if file1 > file2

	movfw	file1
	subwf	file2,W		;file2 - file1, if res -ve then file1 > file2
	btfsc	STATUS,C

	endm

sfgtef	macro	file1,file2	;skip if file1 >= file2

	movfw	file2
	subwf	file1,W		;file1 - file2 , if res 0 or +ve then file1 >= file2
	btfss	STATUS,C

	endm

sfltf	macro	file1,file2	;skip if file1 < file2

	movfw	file2
	subwf	file1,W		;file1 - file2, if res -ve then file1 < file2
	btfsc	STATUS,C

	endm

sfltef	macro	file1,file2	;skip if file1 <= file2

	movfw	file1
	subwf	file2,W		;file2 - file1, if res 0 or +ve then file1 <= file2
	btfss	STATUS,C

	endm

sfef	macro	file1,file2	;skip if file1 == file2

	movfw	file1
	xorwf	file2,W
	btfss	STATUS,Z

	endm

sfnef	macro	file1,file2	;skip if file1 != file2

	movfw	file1
	xorwf	file2,W
	btfsc	STATUS,Z

	endm

;*********************** 16 BIT MULTIPLICATION ********************************************


mpyff	macro	file1, file2, high, low

;=== multiply file 1 x file2, 16 bit result in high/low registers
;=== value of file1 is CHANGED IN ROUTINE
;=== value of file2 is UNALTERED IN ROUTINE

	local	i=0

	clrf	high
	clrf	low

	movfw	file2

	while	i < 8

	rrf	file1,F
	btfsc	STATUS,C
	addwf	high,F
	rrf	high,F
	rrf	low,F
i++
	endw
	endm


mpyfl	macro	file, lit, high, low

;===  multiply file by literal, 16 bit result in high/low registers
;===  value of file CHANGED IN ROUTINE

	local	i=0

	clrf	high
	clrf	low

	movlw	lit

	while	i < 8

	rrf	file,F
	btfsc	STATUS,C
	addwf	high,F
	rrf	high,F
	rrf	low,F
i++
	endw
	endm

;******************************************************************************************

	LIST
